# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.external_resource_entity import ExternalResourceEntity
from typing import Optional, Set
from typing_extensions import Self

class EnvironmentEntryEntity(BaseModel):
    """
    EnvironmentEntryEntity model
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="UUID of the Environment")
    name: Optional[StrictStr] = Field(default=None, description="Name of the Environment")
    slug: Optional[StrictStr] = Field(default=None, description="Slug of the Environment")
    description: Optional[StrictStr] = Field(default=None, description="Description of the Environment")
    updated_at: Optional[datetime] = Field(default=None, description="The time the environment was updated")
    created_at: Optional[datetime] = Field(default=None, description="The time the environment was created")
    active_incidents: Optional[List[StrictStr]] = Field(default=None, description="List of active incident guids")
    external_resources: Optional[List[ExternalResourceEntity]] = Field(default=None, description="Information about known linkages to representations of services outside of FireHydrant.")
    __properties: ClassVar[List[str]] = ["id", "name", "slug", "description", "updated_at", "created_at", "active_incidents", "external_resources"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EnvironmentEntryEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in external_resources (list)
        _items = []
        if self.external_resources:
            for _item_external_resources in self.external_resources:
                if _item_external_resources:
                    _items.append(_item_external_resources.to_dict())
            _dict['external_resources'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EnvironmentEntryEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "slug": obj.get("slug"),
            "description": obj.get("description"),
            "updated_at": obj.get("updated_at"),
            "created_at": obj.get("created_at"),
            "active_incidents": obj.get("active_incidents"),
            "external_resources": [ExternalResourceEntity.from_dict(_item) for _item in obj["external_resources"]] if obj.get("external_resources") is not None else None
        })
        return _obj


