# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.conversations_api_entities_reference import ConversationsAPIEntitiesReference
from firehydrant_api_client.models.severity_matrix_condition_entity import SeverityMatrixConditionEntity
from firehydrant_api_client.models.succinct_entity import SuccinctEntity
from typing import Optional, Set
from typing_extensions import Self

class IncidentsImpactEntity(BaseModel):
    """
    IncidentsImpactEntity
    """ # noqa: E501
    id: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    impact: Optional[SuccinctEntity] = None
    condition: Optional[SeverityMatrixConditionEntity] = None
    conversations: Optional[List[ConversationsAPIEntitiesReference]] = None
    __properties: ClassVar[List[str]] = ["id", "type", "impact", "condition", "conversations"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['environment', 'functionality', 'service']):
            raise ValueError("must be one of enum values ('environment', 'functionality', 'service')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IncidentsImpactEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of impact
        if self.impact:
            _dict['impact'] = self.impact.to_dict()
        # override the default output from pydantic by calling `to_dict()` of condition
        if self.condition:
            _dict['condition'] = self.condition.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in conversations (list)
        _items = []
        if self.conversations:
            for _item_conversations in self.conversations:
                if _item_conversations:
                    _items.append(_item_conversations.to_dict())
            _dict['conversations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IncidentsImpactEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "impact": SuccinctEntity.from_dict(obj["impact"]) if obj.get("impact") is not None else None,
            "condition": SeverityMatrixConditionEntity.from_dict(obj["condition"]) if obj.get("condition") is not None else None,
            "conversations": [ConversationsAPIEntitiesReference.from_dict(_item) for _item in obj["conversations"]] if obj.get("conversations") is not None else None
        })
        return _obj


