# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.put_v1_scim_v2_users_id_emails_inner import PutV1ScimV2UsersIdEmailsInner
from firehydrant_api_client.models.put_v1_scim_v2_users_id_name import PutV1ScimV2UsersIdName
from typing import Optional, Set
from typing_extensions import Self

class PutV1ScimV2UsersId(BaseModel):
    """
    PUT SCIM endpoint to update a User. This endpoint is used to replace a resource's attributes.
    """ # noqa: E501
    user_name: Optional[StrictStr] = Field(default=None, description="A service provider's unique identifier for the user", alias="userName")
    name: Optional[PutV1ScimV2UsersIdName] = None
    emails: Optional[List[PutV1ScimV2UsersIdEmailsInner]] = Field(default=None, description="Email addresses for the User")
    roles: Optional[List[StrictStr]] = Field(default=None, description="Roles for the User")
    active: Optional[StrictBool] = Field(default=None, description="Boolean that represents whether user is active")
    __properties: ClassVar[List[str]] = ["userName", "name", "emails", "roles", "active"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PutV1ScimV2UsersId from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of name
        if self.name:
            _dict['name'] = self.name.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in emails (list)
        _items = []
        if self.emails:
            for _item_emails in self.emails:
                if _item_emails:
                    _items.append(_item_emails.to_dict())
            _dict['emails'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PutV1ScimV2UsersId from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "userName": obj.get("userName"),
            "name": PutV1ScimV2UsersIdName.from_dict(obj["name"]) if obj.get("name") is not None else None,
            "emails": [PutV1ScimV2UsersIdEmailsInner.from_dict(_item) for _item in obj["emails"]] if obj.get("emails") is not None else None,
            "roles": obj.get("roles"),
            "active": obj.get("active")
        })
        return _obj


